#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "font.h"
#include "jstr.h"
#include "file.h"

#include "xpm/font/tofu16.xpm"
#include "xpm/font/space16.xpm"
#include "xpm/font/kuten16.xpm"
#include "xpm/font/toten16.xpm"
#include "xpm/font/nakaguro16.xpm"
#include "xpm/font/question16.xpm"
#include "xpm/font/bikkuri16.xpm"
#include "xpm/font/ldots16a.xpm"
#include "xpm/font/lbracket16.xpm"
#include "xpm/font/rbracket16.xpm"
#include "xpm/font/lparen16.xpm"
#include "xpm/font/rparen16.xpm"
#include "xpm/font/lkagikakko16.xpm"
#include "xpm/font/rkagikakko16.xpm"
#include "xpm/font/a16a.xpm"
#include "xpm/font/i16a.xpm"
#include "xpm/font/u16a.xpm"
#include "xpm/font/e16a.xpm"
#include "xpm/font/o16a.xpm"
#include "xpm/font/la16a.xpm"
#include "xpm/font/li16a.xpm"
#include "xpm/font/lu16a.xpm"
#include "xpm/font/le16a.xpm"
#include "xpm/font/lo16a.xpm"

#include "xpm/font/ka16a.xpm"
#include "xpm/font/ki16a.xpm"
#include "xpm/font/ku16a.xpm"
#include "xpm/font/ke16a.xpm"
#include "xpm/font/ko16a.xpm"

#include "xpm/font/ga16a.xpm"
#include "xpm/font/gi16a.xpm"
#include "xpm/font/gu16a.xpm"
#include "xpm/font/ge16a.xpm"
#include "xpm/font/go16a.xpm"

#include "xpm/font/sa16a.xpm"
#include "xpm/font/si16a.xpm"
#include "xpm/font/su16a.xpm"
#include "xpm/font/se16a.xpm"
#include "xpm/font/so16a.xpm"

#include "xpm/font/za16a.xpm"
#include "xpm/font/zi16a.xpm"
#include "xpm/font/zu16a.xpm"
#include "xpm/font/ze16a.xpm"
#include "xpm/font/zo16a.xpm"

#include "xpm/font/ta16a.xpm"
#include "xpm/font/ti16a.xpm"
#include "xpm/font/tu16a.xpm"
#include "xpm/font/te16a.xpm"
#include "xpm/font/to16a.xpm"
#include "xpm/font/ltu16a.xpm"
#include "xpm/font/da16a.xpm"
#include "xpm/font/di16a.xpm"
#include "xpm/font/du16a.xpm"
#include "xpm/font/de16a.xpm"
#include "xpm/font/do16a.xpm"

#include "xpm/font/na16a.xpm"
#include "xpm/font/ni16a.xpm"
#include "xpm/font/nu16a.xpm"
#include "xpm/font/ne16a.xpm"
#include "xpm/font/no16a.xpm"

#include "xpm/font/ha16a.xpm"
#include "xpm/font/hi16a.xpm"
#include "xpm/font/hu16a.xpm"
#include "xpm/font/he16a.xpm"
#include "xpm/font/ho16a.xpm"

#include "xpm/font/ba16a.xpm"
#include "xpm/font/bi16a.xpm"
#include "xpm/font/bu16a.xpm"
#include "xpm/font/be16a.xpm"
#include "xpm/font/bo16a.xpm"

#include "xpm/font/pa16a.xpm"
#include "xpm/font/pi16a.xpm"
#include "xpm/font/pu16a.xpm"
#include "xpm/font/pe16a.xpm"
#include "xpm/font/po16a.xpm"

#include "xpm/font/ma16a.xpm"
#include "xpm/font/mi16a.xpm"
#include "xpm/font/mu16a.xpm"
#include "xpm/font/me16a.xpm"
#include "xpm/font/mo16a.xpm"

#include "xpm/font/ya16a.xpm"
#include "xpm/font/yu16a.xpm"
#include "xpm/font/yo16a.xpm"
#include "xpm/font/lya16a.xpm"
#include "xpm/font/lyu16a.xpm"
#include "xpm/font/lyo16a.xpm"

#include "xpm/font/ra16a.xpm"
#include "xpm/font/ri16a.xpm"
#include "xpm/font/ru16a.xpm"
#include "xpm/font/re16a.xpm"
#include "xpm/font/ro16a.xpm"

#include "xpm/font/wa16a.xpm"
#include "xpm/font/wo16a.xpm"
#include "xpm/font/n16.xpm"

#include "xpm/font/n0_16a.xpm"
#include "xpm/font/n1_16a.xpm"
#include "xpm/font/n2_16a.xpm"
#include "xpm/font/n3_16a.xpm"
#include "xpm/font/n4_16a.xpm"
#include "xpm/font/n5_16a.xpm"
#include "xpm/font/n6_16a.xpm"
#include "xpm/font/n7_16a.xpm"
#include "xpm/font/n8_16a.xpm"
#include "xpm/font/n9_16a.xpm"

#include "xpm/font/al_c16a.xpm"
#include "xpm/font/al_f16a.xpm"
#include "xpm/font/al_o16a.xpm"
#include "xpm/font/al_n16a.xpm"
#include "xpm/font/al_s16a.xpm"


#include "xpm/font/key_g16.xpm"
#include "xpm/font/key_p16.xpm"
#include "xpm/font/key_q16.xpm"
#include "xpm/font/key_r16.xpm"
#include "xpm/font/key_leftarrow16.xpm"
#include "xpm/font/key_rightarrow16.xpm"
#include "xpm/font/key_uparrow16.xpm"
#include "xpm/font/key_downarrow16.xpm"
#include "xpm/font/key_spacel16.xpm"
#include "xpm/font/key_spacer16.xpm"
#include "xpm/font/key_esc16.xpm"
#include "xpm/font/key_enter16.xpm"

#include "xpm/font/time16.xpm"
#include "xpm/font/gondin16.xpm"
#include "xpm/font/gondin_lost16.xpm"
#include "xpm/font/walk16_2.xpm"
#include "xpm/font/jump16.xpm"
#include "xpm/font/air16.xpm"
#include "xpm/font/lift16.xpm"
#include "xpm/font/blast16.xpm"
#include "xpm/font/sting16.xpm"
#include "xpm/font/bone16.xpm"
#include "xpm/font/smash16.xpm"
#include "xpm/font/flame16.xpm"
#include "xpm/font/barrier16.xpm"
#include "xpm/font/goal16.xpm"

#include "xpm/font/chee_l16.xpm"
#include "xpm/font/hatopo16.xpm"
#include "xpm/font/yaramasi16.xpm"
#include "xpm/font/gagga16.xpm"
#include "xpm/font/sue16.xpm"
#include "xpm/font/ojigiri16.xpm"
#include "xpm/font/chu16.xpm"
#include "xpm/font/jumeme16.xpm"
#include "xpm/font/siguku16.xpm"
#include "xpm/font/mingo16.xpm"
#include "xpm/font/ppit16.xpm"
#include "xpm/font/ppit_jump16.xpm"
#include "xpm/font/fwall16.xpm"
#include "xpm/font/iwall16.xpm"
#include "xpm/font/switch16.xpm"
#include "xpm/font/teleporter16.xpm"

#include "xpm/font/plus16.xpm"
#include "xpm/font/multiply16.xpm"
#include "xpm/font/slash16.xpm"
#include "xpm/font/equal16.xpm"
#include "xpm/font/op_lt16.xpm"
#include "xpm/font/op_gt16.xpm"
#include "xpm/font/op_le16.xpm"
#include "xpm/font/op_ge16.xpm"
#include "xpm/font/checkbox16.xpm"
#include "xpm/font/check16.xpm"
#include "xpm/font/check_weak16.xpm"
#include "xpm/font/star_off16.xpm"
#include "xpm/font/star_on16.xpm"

#include "xpm/font/dash16a.xpm"

static EzImage tofu_font;

static EzImage fonts[fi_end];

font_info_t font_infos[] = {
    {fi_space, "　", space16_xpm},
    {fi_space, " ", space16_xpm},
    {fi_kuten, "、", kuten16_xpm},
    {fi_toten, "。", toten16_xpm},
    {fi_nakaguro, "・", nakaguro16_xpm},
    {fi_question, "？", question16_xpm},
    {fi_bikkuri, "！", bikkuri16_xpm},
    {fi_dash, "ー", dash16_xpm},
    {fi_ldots, "…", ldots16_xpm},
    {fi_lbracket, "[", lbracket16_xpm},
    {fi_rbracket, "]", rbracket16_xpm},
    {fi_lparen, "（", lparen16_xpm},
    {fi_rparen, "）", rparen16_xpm},
    {fi_lkagikakko, "「", lkagikakko16_xpm},
    {fi_rkagikakko, "」", rkagikakko16_xpm},
    {fi_a, "あ", a16_xpm},
    {fi_i, "い", i16_xpm},
    {fi_u, "う", u16_xpm},
    {fi_e, "え", e16_xpm},
    {fi_o, "お", o16_xpm},
    {fi_la, "ぁ", la16_xpm},
    {fi_li, "ぃ", li16_xpm},
    {fi_lu, "ぅ", lu16_xpm},
    {fi_le, "ぇ", le16_xpm},
    {fi_lo, "ぉ", lo16_xpm},

    {fi_ka, "か", ka16_xpm},
    {fi_ki, "き", ki16_xpm},
    {fi_ku, "く", ku16_xpm},
    {fi_ke, "け", ke16_xpm},
    {fi_ko, "こ", ko16_xpm},

    {fi_ga, "が", ga16_xpm},
    {fi_gi, "ぎ", gi16_xpm},
    {fi_gu, "ぐ", gu16_xpm},
    {fi_ge, "げ", ge16_xpm},
    {fi_go, "ご", go16_xpm},

    {fi_sa, "さ", sa16_xpm},
    {fi_si, "し", si16_xpm},
    {fi_su, "す", su16_xpm},
    {fi_se, "せ", se16_xpm},
    {fi_so, "そ", so16_xpm},
    {fi_za, "ざ", za16_xpm},
    {fi_zi, "じ", zi16_xpm},
    {fi_zu, "ず", zu16_xpm},
    {fi_ze, "ぜ", ze16_xpm},
    {fi_zo, "ぞ", zo16_xpm},

    {fi_ta, "た", ta16_xpm},
    {fi_ti, "ち", ti16_xpm},
    {fi_tu, "つ", tu16_xpm},
    {fi_te, "て", te16_xpm},
    {fi_to, "と", to16_xpm},
    {fi_ltu, "っ", ltu16_xpm},
    {fi_da, "だ", da16_xpm},
    {fi_di, "ぢ", di16_xpm},
    {fi_du, "づ", du16_xpm},
    {fi_de, "で", de16_xpm},
    {fi_do, "ど", do16_xpm},

    {fi_na, "な", na16_xpm},
    {fi_ni, "に", ni16_xpm},
    {fi_nu, "ぬ", nu16_xpm},
    {fi_ne, "ね", ne16_xpm},
    {fi_no, "の", no16_xpm},
    {fi_ha, "は", ha16_xpm},
    {fi_hi, "ひ", hi16_xpm},
    {fi_hu, "ふ", hu16_xpm},
    {fi_he, "へ", he16_xpm},
    {fi_ho, "ほ", ho16_xpm},
    {fi_ba, "ば", ba16_xpm},
    {fi_bi, "び", bi16_xpm},
    {fi_bu, "ぶ", bu16_xpm},
    {fi_be, "べ", be16_xpm},
    {fi_bo, "ぼ", bo16_xpm},
    {fi_pa, "ぱ", pa16_xpm},
    {fi_pi, "ぴ", pi16_xpm},
    {fi_pu, "ぷ", pu16_xpm},
    {fi_pe, "ぺ", pe16_xpm},
    {fi_po, "ぽ", po16_xpm},
    {fi_ma, "ま", ma16_xpm},
    {fi_mi, "み", mi16_xpm},
    {fi_mu, "む", mu16_xpm},
    {fi_me, "め", me16_xpm},
    {fi_mo, "も", mo16_xpm},
    {fi_ya, "や", ya16_xpm},
    {fi_yu, "ゆ", yu16_xpm},
    {fi_yo, "よ", yo16_xpm},
    {fi_lya, "ゃ", lya16_xpm},
    {fi_lyu, "ゅ", lyu16_xpm},
    {fi_lyo, "ょ", lyo16_xpm},
    {fi_ra, "ら", ra16_xpm},
    {fi_ri, "り", ri16_xpm},
    {fi_ru, "る", ru16_xpm},
    {fi_re, "れ", re16_xpm},
    {fi_ro, "ろ", ro16_xpm},
    {fi_wa, "わ", wa16_xpm},
    {fi_wo, "を", wo16_xpm},
    {fi_n, "ん", n16_xpm},

    {fi_n0, "0", n0_16_xpm},
    {fi_n1, "1", n1_16_xpm},
    {fi_n2, "2", n2_16_xpm},
    {fi_n3, "3", n3_16_xpm},
    {fi_n4, "4", n4_16_xpm},
    {fi_n5, "5", n5_16_xpm},
    {fi_n6, "6", n6_16_xpm},
    {fi_n7, "7", n7_16_xpm},
    {fi_n8, "8", n8_16_xpm},
    {fi_n9, "9", n9_16_xpm},

    {fi_al_c, "C", al_c16_xpm},
    {fi_al_f, "F", al_f16_xpm},
    {fi_al_o, "O", al_o16_xpm},
    {fi_al_n, "N", al_n16_xpm},
    {fi_al_s, "S", al_s16_xpm},
    /*
	{fi_ky_g, "G", key_g16_xpm},
	{fi_ky_p, "P", key_p16_xpm},
	{fi_ky_r, "R", key_r16_xpm},
	{fi_ky_q, "Q", key_q16_xpm},
	{fi_ky_leftarrow, "←", key_leftarrow16_xpm},
	{fi_ky_rightarrow, "→", key_rightarrow16_xpm},
	{fi_ky_uparrow, "↑", key_uparrow16_xpm},
	{fi_ky_downarrow, "↓", key_downarrow16_xpm},
	{fi_ky_spacel, "空", key_spacel16_xpm},
	{fi_ky_spacer, "白", key_spacer16_xpm},
	{fi_ky_esc, "脱", key_esc16_xpm},
	{fi_ky_enter, "改", key_enter16_xpm},
    */
	{fi_ky_g, "#KeyG", key_g16_xpm},
	{fi_ky_p, "#KeyP", key_p16_xpm},
	{fi_ky_r, "#KeyR", key_r16_xpm},
	{fi_ky_q, "#KeyQ", key_q16_xpm},
	{fi_ky_leftarrow, "#KeyLeft", key_leftarrow16_xpm},
	{fi_ky_rightarrow, "#KeyRight", key_rightarrow16_xpm},
	{fi_ky_uparrow, "#KeyUp", key_uparrow16_xpm},
	{fi_ky_downarrow, "#KeyDown", key_downarrow16_xpm},
	{fi_ky_spacel, "#KeySpaceLeft", key_spacel16_xpm},
	{fi_ky_spacer, "#KeySpaceRight", key_spacer16_xpm},
	{fi_ky_esc, "#KeyEsc", key_esc16_xpm},
	{fi_ky_enter, "#KeyEnter", key_enter16_xpm},

    //	{fi_time, "時", time16_xpm},
	//  {fi_gondin, "実", gondin16_xpm},
    //	{fi_gondin_lost, "餓", gondin_lost16_xpm},
    //	{fi_walk, "歩", walk16_xpm},
    //	{fi_jump, "跳", jump16_xpm},
	//  {fi_air, "飛", air16_xpm},
	//  {fi_lift, "昇", lift16_xpm},
    //	{fi_blast, "撃", blast16_xpm},
    {fi_time, "#Time", time16_xpm},
	{fi_gondin, "#Gondin", gondin16_xpm},
	{fi_gondin_lost, "#GondinLost", gondin_lost16_xpm},
    {fi_walk, "#Walk", walk16_xpm},
    {fi_jump, "#Jump", jump16_xpm},
	{fi_air, "#Air", air16_xpm},
	{fi_lift, "#Lift", lift16_xpm},
	{fi_blast, "#Blast", blast16_xpm},

    //	{fi_sting, "棘", sting16_xpm},
    //	{fi_bone, "骨", bone16_xpm},
    //	{fi_smash, "潰", smash16_xpm},
    //	{fi_flame, "炎", flame16_xpm},
    //	{fi_flame, "扉", goal16_xpm},
	{fi_sting, "#Sting", sting16_xpm},
	{fi_bone, "#Bone", bone16_xpm},
	{fi_smash, "#Smash", smash16_xpm},
	{fi_flame, "#Flame", flame16_xpm},
	{fi_barrier, "#Barrier", barrier16_xpm},
    {fi_goal, "#Goal", goal16_xpm},

    //	{fi_chee, "主", chee_l16_xpm},
    //	{fi_hatopo, "鳩", hatopo16_xpm},
    //	{fi_yaramasi, "山", yaramasi16_xpm},
    //	{fi_gagga, "熊", gagga16_xpm},
    //	{fi_sue, "竜", sue16_xpm},
    //	{fi_ojigiri, "草", ojigiri16_xpm},
    //	{fi_chu, "鼠", chu16_xpm},
    //	{fi_fwall, "壁", fwall16_xpm},
    //	{fi_iwall, "氷", iwall16_xpm},
    //	{fi_switch, "換", switch16_xpm},
    //	{fi_teleporter, "転", teleporter16_xpm},
	{fi_chee, "#Chee", chee_l16_xpm},
	{fi_hatopo, "#Hatopo", hatopo16_xpm},
	{fi_yaramasi, "#Yaramasi", yaramasi16_xpm},
	{fi_gagga, "#Gagga", gagga16_xpm},
	{fi_sue, "#Sue", sue16_xpm},
	{fi_ojigiri, "#Ojigiri", ojigiri16_xpm},
	{fi_chu, "#Chu", chu16_xpm},
	{fi_jumeme, "#Jumeme", jumeme16_xpm},
	{fi_siguku, "#Siguku", siguku16_xpm},
	{fi_mingo, "#Mingo", mingo16_xpm},
    {fi_ppit, "#PPit", ppit16_xpm},
    {fi_ppit_jump, "#PPitJump", ppit_jump16_xpm},
	{fi_fwall, "#FWall", fwall16_xpm},
	{fi_iwall, "#IWall", iwall16_xpm},
	{fi_switch, "#Switch", switch16_xpm},
	{fi_teleporter, "#Teleporter", teleporter16_xpm},

	{fi_plus, "+",plus16_xpm},
	{fi_multiply, "*", multiply16_xpm},
	{fi_slash, "/", slash16_xpm},
	{fi_equal, "=", equal16_xpm},
	{fi_op_lt, "<", op_lt16_xpm},
	{fi_op_gt, ">", op_gt16_xpm},
	{fi_op_le, "≦", op_le16_xpm},
	{fi_op_ge, "≧", op_ge16_xpm},
	{fi_checkbox, "□", checkbox16_xpm},
	{fi_check, "■", check16_xpm},
	{fi_check_weak, "▲", check_weak16_xpm},
    //	{fi_star_off, "☆", star_off16_xpm},
    //	{fi_star_on, "★", star_on16_xpm},
    {fi_star_off, "#StarOff", star_off16_xpm},
    {fi_star_on, "#StarOn", star_on16_xpm},

};
#define FONT_INFO_NUM (sizeof(font_infos)/sizeof(font_info_t))

font_name_t font_name_infos[FONT_NAME_NUM_MAX];
int font_name_num = 0;


static char *str_la = "ぁ";
//static char *str_a = "あ";
static char *str_n = "ん";
static char *str_symbol = "　、。・！？ー←→↑↓…（）「」□■▲☆★";
//static char *str_kanji = "時実餓空白脱改歩跳飛昇撃棘骨潰炎扉主鳩山熊竜草鼠壁氷換転";
static char *str_kanji = "";
static unsigned int code_kana_min;
static unsigned int code_kana_max;
static unsigned int code_symbol_min = 0xffffffff;
static unsigned int code_symbol_max = 0;
static unsigned int code_kanji_min = 0xffffffff;
static unsigned int code_kanji_max = 0;

static font_id_t fix2fid[FIX_MAX];


static font_id_t *fontseq_buf = NULL;
static int fontseq_buf_usednum = 0;

static font_id_t **fontseq_array_buf = NULL;
static int fontseq_array_buf_usednum = 0;


void font_init(void){
    int i, byte;
    int fix;
    unsigned int code;
	char *p;

    tofu_font = EzReadXPM(tofu16_xpm);
    for (i = 0 ; i < fi_end ; i++){
        fonts[i]= tofu_font;
    }
    p = str_la;
    code_kana_min = jstrcode(p, &byte);
    printf("code_kana_min=%d\n", code_kana_min);
    p = str_n;
    code_kana_max = jstrcode(p, &byte);
    printf("code_kana_max=%d\n", code_kana_max);
    p = str_symbol;
    while (*p != '\0'){
        code = jstrcode(p, &byte);
        p += byte;
        if (code < code_symbol_min) code_symbol_min = code;
        if (code > code_symbol_max) code_symbol_max = code;
    }
    printf("code_symbol_min=%d\n", code_symbol_min);
    printf("code_symbol_max=%d\n", code_symbol_max);
    p = str_kanji;
    while (*p != '\0'){
        code = jstrcode(p, &byte);
        p += byte;
        if (code < code_kanji_min) code_kanji_min = code;
        if (code > code_kanji_max) code_kanji_max = code;
    }
    //    printf("code_kanji_min=%d\n", code_kanji_min);
    //    printf("code_kanji_max=%d\n", code_kanji_max);

    for (i = 0 ; i < FONT_INFO_NUM ; i++){
        fonts[font_infos[i].fid] = EzReadXPM(font_infos[i].xpm);
        if (font_infos[i].mbchr[0] == '#'){
            font_name_infos[font_name_num].font_name = &font_infos[i].mbchr[1];
            font_name_infos[font_name_num].fid = font_infos[i].fid;
            font_name_num ++;
        }
        else {
            p = font_infos[i].mbchr;
            // mbchr2fixはポインタを進めるので、mbchrをpにコピーしてから渡す
            fix = mbchr2fix(&p);
            //            printf("fix2fid:%d->%d\n", fix, fix2fid[fix]);
            assert(fix < FIX_MAX);
            fix2fid[fix] = font_infos[i].fid;
            //            printf("fix2fid:%d->%d\n", fix, fix2fid[fix]);
        }
    }
    // '['は"[FontName]"形式で使うメタ文字なので別途登録
    // mbchr2fixで特別扱いいているため上記ループ内で処理できない
    //    fonts[fi_lbracket] = EzReadXPM(lbracket16_xpm);
    //    fix2fid['['] = fi_lbracket;

    for (i = 0 ; i < font_name_num ; i++){
        //        printf("FontName%3d/%3d id=%3d %s\n", i+1, font_name_num, 
        //font_name_infos[i].fid, font_name_infos[i].font_name);
    }
}


void draw_font(int x, int y, font_id_t fid){
    //    printf("fid=%d\n", fid);
    assert(fid < fi_end);
    EzPutB(x, y, fonts[fid]);
}

void draw_fontseq(int x, int y, font_id_t *fid){
    while (*fid != fi_end){
        draw_font(x, y, *fid);
        x += 16;
		fid ++;
    }
}

#define KANA_OFFSET 128
#define SYMBOL_OFFSET (code_kana_max-code_kana_min+KANA_OFFSET+1)
#define KANJI_OFFSET (code_symbol_max-code_symbol_min+SYMBOL_OFFSET+1)

font_id_t font_name2fid(char *font_name){
    int i;
    for (i = 0 ; i < font_name_num ; i++){
        //        printf("font_name2fid |%s|%s|\n", font_name, font_name_infos[i].font_name);
        if (strcmp(font_name, font_name_infos[i].font_name) == 0){
            //            printf("found fid=%d\n", font_name_infos[i].fid);
            return font_name_infos[i].fid;
        }
    }
    return fi_tofu;
}


int mbchr2fix(char **chr){
    unsigned int code;
    int byte;

    //            printf("chr:'%s'", *chr);
    code = jstrcode(*chr, &byte);
    *chr += byte;
    //    printf(" code %d byte %d\n", code, byte);

    if (byte == 1){
        return code;
    }
    else if (code_kana_min <= code && code <= code_kana_max){
        return code - code_kana_min + KANA_OFFSET;
    }
    else if (code_symbol_min <= code && code <= code_symbol_max){
        return code - code_symbol_min + SYMBOL_OFFSET;
    }
    else if (code_kanji_min <= code && code <= code_kanji_max){
        return code - code_kanji_min + KANJI_OFFSET;
    }
    else {
        log_error("Unknown code %d (%s %dbyte)\n", code, *chr-byte, byte);
        exit(1);
        return 0;
    }
}

int str2fontseq(char *str, font_id_t fid[]){
    int font_num=0;
    int fix;

	while (*str != '\0'){
        // [FontName]"形式の処理
        // ※マルチバイト文字対応で先頭から見ているから、
        //   次がマルチバイト文字のとき'['と一致してしまうことはない
        if (*str == '['){
            // '[['は'['として扱う
            if (*(str+1) == '['){
                str++;
                fix = mbchr2fix(&str);
                fid[font_num] = fix2fid[fix];
            }
            else {
                char font_name[256];
                char *cp;
                str ++;
                cp = font_name;
                while (*str != ']' && *str != '\0'){
                    *cp = *str;
                    cp ++;
                    str ++;
                }
                str ++;
                *cp = '\0';
                //                printf("font_name|%s|\n", font_name);
                fid[font_num] = font_name2fid(font_name);
            }
        }
        else {
            fix = mbchr2fix(&str);
            fid[font_num] = fix2fid[fix];
        }
		font_num++;
        //        printf("%s->%d\n", str, fid[font_num-1]);
	}
	fid[font_num] = fi_end;
	font_num++;
    return font_num;
}

font_id_t *alloc_fontseq(char *str){
	int font_num;
    int len;
	font_id_t *fs;

    len = strlen(str);

	if (fontseq_buf == NULL || fontseq_buf_usednum + len + 1 > FONTSEQ_ARRAY_BUF_SIZE){
		fontseq_buf = malloc(sizeof(font_id_t)*FONTSEQ_BUF_SIZE);
        //        printf("malloc fontseq_buf:%p\n", fontseq_buf);
		assert(fontseq_buf != NULL);
	}
	font_num = str2fontseq(str, fontseq_buf);
	fs = fontseq_buf;
	fontseq_buf += font_num;
	fontseq_buf_usednum += font_num;
	return fs;
}

font_id_t **alloc_fontseq_array(int size){
	font_id_t **fa;

    if (size > FONTSEQ_ARRAY_PACK_LIMIT){
        return malloc(sizeof(font_id_t*) * size);
    }
    if (fontseq_array_buf == NULL || fontseq_array_buf_usednum + size
        > FONTSEQ_ARRAY_BUF_SIZE)
    {
        fontseq_array_buf = malloc(sizeof(font_id_t*) * FONTSEQ_ARRAY_BUF_SIZE);
        //        printf("malloc fontseq_array_buf:%p\n", fontseq_array_buf);
		assert(fontseq_array_buf != NULL);
    }
    fa = fontseq_array_buf;
    fontseq_array_buf += size;
    fontseq_array_buf_usednum += size;
    return fa;
}

int fontseq_cpy(font_id_t *dest, font_id_t *src){
    int num = 0;

    while (*src != fi_end){
        *dest = *src;
        //        printf("fontseq_cpy(%d, %d)\n", *dest, *src);
        dest ++;
        src ++;
        num ++;
    }
    *dest = fi_end;
    return num;
} 

int fontseq_len(font_id_t *fontseq){
	int len = 0;
	while (*fontseq != fi_end){
		len ++;
		fontseq ++;
	}
	return len;
}


int fontseq_cat(font_id_t *dest, font_id_t *src){
    int num;

	num = fontseq_len(dest);
	dest += num;
	num += fontseq_cpy(dest, src);
    return num;
} 


// 0または正の整数値nをlen桁のフォント列に変換する
// ※fi_endを格納するためfid[]はlen+1のサイズが必要
// ※nの桁数がlenを超える時は、上位の桁が打ち切られる
int uint2fontseq(unsigned int n, int len, font_id_t fid[]){
	int i= len-1;
	fid[len] = fi_end;
    // nが0のときはループに入れないので別扱い
    if (n == 0){
        fid[i] = fi_n0;
        i--;
    }
    else {
        while (n != 0){
            // あふれたときは格納のみスキップして続行
            if (i >= 0){
                fid[i] = (font_id_t)(fi_n0 + n % 10);
            }
            n /= 10;
            i--;
        }
    }
	while (i >= 0){
		fid[i] = fi_space;
		i--;
	}
	return len-i+1;
}

// 桁数lenの整数フォント列(fi_n0～fi_n9のみで構成)に対し、
// 内容を1増やす
// オーバフローしたら非0を返す
int inc_fontseq(int len, font_id_t fid[]){
    int i = len-1;

    while (i >= 0){
        if (fid[i] == fi_n9){
            fid[i] = fi_n0;
            i--;
        }
        else if (fid[i] == fi_space){
            fid[i] = fi_n1;
            break;
        }
        else {
            fid[i]++;
            break;
        }
    }
    if (i >= 0){
        return 0;
    }
    else {
        return 1;
    }
}
// 桁数lenの整数フォント列(fi_n0～fi_n9のみで構成)に対し、
// 内容を1減らす
// オーバフローしたら非0を返す
int dec_fontseq(int len, font_id_t fid[]){
    int i = len-1;

    while (i >= 0){
        if (fid[i] == fi_n0){
            fid[i] = fi_n9;
            i--;
        }
        else if (fid[i] == fi_space){
            return 1;
        }
        else {
            fid[i]--;
			if (fid[i] == fi_n0 && i < len-1){
				if (i == 0 || fid[i-1] == fi_space){
					fid[i] = fi_space;
				}
			}
            return 0;
        }
    }
	return 1;
}
