#ifndef GAME_H
#define GAME_H
#include "config.h"
#include "stage.h"
#include "param.h"
#include "uty.h"

typedef enum {
              gs_working,
              gs_growing,
              gs_shrinking,
              gs_clear,
} game_state_t;


game_state_t get_game_state(void);
void set_game_state(game_state_t state);

void game_init(void);
void setup_game(void);
void game_keyh(int key);
void game_key_releaseh(int key);
void game_timerh(void);
void quit_game(void);
void retry_game(void);

int get_player_x(void);
int get_player_y(void);
void set_player_xy(int x, int y);
void move(dir_t dir);
void move_player(int nx, int ny, map_element_t me, map_element_t nme);

//void update_route_value(int x, int y);

#endif





