#ifndef UTY_H
#define UTY_H
#include "config.h"

typedef struct {
    int x, y;
} pos_t;

typedef enum {di_invalid=-1,
              di_begin = 0, di_down=0,
              di_left,
              di_up,
              di_right,
              di_end
} dir_t;

extern pos_t dir2offset[4];
#define OffsetX(dir) (dir2offset[dir].x)                              
#define OffsetY(dir) (dir2offset[dir].y)                              

#define ReverseDir(dir) (((dir)+2) % 4)

extern char *dir2chr_str;
#define Dir2Chr(dir) (dir2chr_str[dir+1])

#endif
